<template>
  <q-page class="q-px-md q-mt-md">
    <div class="row q-gutter-x-sm">
      <div class="col-md-12">
        <q-card class="q-px-sm ">
          <q-card-section class="q-py-none ">
            <h6 class="q-my-sm q-pt-md">รายงานผลประกอบการ</h6>
          </q-card-section>
          <q-card-section>
            <div class="row q-gutter-x-sm">
              <div
                class="col-auto text-right"
                style="line-height: 40px; min-width: 80px;"
              >
                ประเภทเกม
              </div>
              <div class="col">
                <q-checkbox
                  v-model="game_type"
                  :key="item.code"
                  v-for="item in groupList"
                  :val="item.code"
                  :label="item.code"
                />
              </div>
            </div>
          </q-card-section>
          <q-card-section class="q-py-none">
            <div class="row q-gutter-x-sm">
              <div
                class="col-auto text-right"
                style="line-height: 50px; min-width: 80px;"
              >
                ผู้ให้บริการ
              </div>
              <div class="col-10 col-md-auto">
                <q-select
                  outlined
                  dense
                  v-model="provider_code"
                  multiple
                  :options="providerList"
                  option-value="code"
                  option-label="name"
                  emit-value
                  style="min-width: 250px; "
                >
                  <template v-if="provider_code.length > 0" v-slot:append>
                    <q-icon
                      name="cancel"
                      @click.stop="provider_code = []"
                      class="cursor-pointer"
                    />
                  </template>
                </q-select>
              </div>
            </div>
          </q-card-section>
          <q-card-section class="q-py-none">
            <StartDateEndDateFilterComponent :filter="dateFilter" />
          </q-card-section>
          <q-card-section class="q-py-sm">
            <q-btn color="green" @click.prevent="onSearch" icon="search"
              >ค้นหา</q-btn
            >
          </q-card-section>

          <q-table
            :rows-per-page-options="[15, 25, 50]"
            v-if="data"
            :pagination.sync="pagination"
            :loading="loading"
            :data="[{}]"
            separator="cell"
            row-key="id"
            @request="onRequest"
          >
            <template slot="header" slot-scope="props" :props="props">
              <q-tr>
                <q-th rowspan="2" class="bg-blue-9 text-white">
                  ยูสเซอร์เนม
                </q-th>
                <!-- <q-th
                  v-for="(item, index) in data.report"
                  :key="index"
                  colspan="1"
                  class="bg-blue-10 text-white"
                  >{{ $convert.level(item.level) }}</q-th
                > -->
                <q-th colspan="1" class="bg-blue-10 text-white">สมาชิก</q-th>
                <q-th colspan="1" class="bg-blue-10 text-white">เอเย่น</q-th>
                <q-th v-if="role <= 5" colspan="1" class="bg-blue-10 text-white"
                  >ซีเนียร์</q-th
                >
                <q-th v-if="role <= 4" colspan="1" class="bg-blue-10 text-white"
                  >ผู้ถือหุ่น</q-th
                >
                <q-th v-if="role <= 3" colspan="1" class="bg-blue-10 text-white"
                  >คอมปะนี</q-th
                >
                <q-th v-if="role <= 2" colspan="1" class="bg-blue-10 text-white"
                  >Staff</q-th
                >
                <q-th v-if="role <= 1" colspan="1" class="bg-blue-10 text-white"
                  >Admin</q-th
                >
              </q-tr>
              <q-tr>
                <q-th
                  class="bg-light-blue-5 text-white"
                  v-for="index in role < 2 ? 7 : 6 - role + 2"
                  :key="index"
                  >W/L
                </q-th>
              </q-tr>
            </template>
            <template slot="body" slot-scope="props" :props="props">
              <!-- <Row :key="`${props.row.id}_${+new Date()}`" :row="props.row" /> -->
              <tr>
                <td class="text-center">{{ data.username }} {{ role }}</td>
                <td class="text-center" :class="bgFunc(getWinLose(6))">
                  {{ getWinLose(6) }}
                </td>
                <td class="text-center" :class="bgFunc(getWinLose(5))">
                  {{ getWinLose(5) }}
                </td>
                <td
                  class="text-center"
                  v-if="role <= 5"
                  :class="bgFunc(getWinLose(4))"
                >
                  {{ getWinLose(4) }}
                </td>
                <td
                  class="text-center"
                  v-if="role <= 4"
                  :class="bgFunc(getWinLose(3))"
                >
                  {{ getWinLose(3) }}
                </td>
                <td
                  class="text-center"
                  v-if="role <= 3"
                  :class="bgFunc(getWinLose(2))"
                >
                  {{ getWinLose(2) }}
                </td>
                <td
                  class="text-center"
                  v-if="role <= 2"
                  :class="bgFunc(getWinLose(1))"
                >
                  {{ getWinLose(1) }}
                </td>
                <td
                  class="text-center"
                  v-if="role <= 1"
                  :class="bgFunc(getWinLose(0))"
                >
                  {{ getWinLose(0) }}
                </td>

                <!-- <td
                  v-for="(item, index) in data.report"
                  class="text-center"
                  :class="bgFunc(getWL(item, index))"
                  :key="index"
                >
                  {{ numberWithCommas(getWL(item, index)) }}
                </td> -->
              </tr>
            </template>
            <template v-slot:loading>
              <q-inner-loading showing color="primary" />
            </template>
          </q-table>
        </q-card>
      </div>
    </div>
  </q-page>
</template>
<script>
import { mapState, mapGetters, mapActions } from "vuex";
import { SessionStorage, LocalStorage } from "quasar";
import Row from "./index_tr";
import StartDateEndDateFilterComponent from "components/StartDateEndDateFilterComponent";
import { target } from "vuelidate/lib/params";

const sessionKey = "filter_report_member_";
const username = LocalStorage.getItem("username");
export default {
  name: "Index",
  components: {
    StartDateEndDateFilterComponent
    // Row
  },
  data() {
    return {
      data: null,
      // tableData:{}
      loading: false,
      dateFilter: {
        startDate: 1625097600000,
        //  new Date().setDate(1),
        startTime: new Date(new Date().setHours(0, 0, 0, 0)),
        endDate: new Date(
          new Date().getFullYear(),
          new Date().getMonth() + 1
        ).setDate(0),
        endTime: new Date(new Date().setHours(23, 59, 59, 999))
      },
      game_type: [],
      provider_code: [],
      filter: {
        username: undefined,
        parent_id: undefined,
        level: undefined
      },
      pagination: {
        sortBy: "desc",
        descending: false,
        page: 1,
        rowsPerPage: 15,
        rowsNumber: 0
      },
      groupList: [],
      providerList: []
    };
  },

  async created() {
    document.title = "Report";
    if (SessionStorage.getItem(`group_list_filter`)) {
      this.groupList = SessionStorage.getItem(`group_list_filter`);
      this.game_type = this.groupList
        .filter(
          (item, index) =>
            this.groupList.findIndex(r => r.code == item.code) == index
        )
        .map(x => x.code);
    }
    if (SessionStorage.getItem(`provider_list_filter`)) {
      this.providerList = SessionStorage.getItem(`provider_list_filter`);
    } else {
      try {
        const { data } = await this.load_provider();
        if (data) {
          this.providerList = data
            .filter(
              (item, index) => data.findIndex(r => r.code == item.code) == index
            )
            .map(x => {
              return {
                code: x.code,
                name: x.name
              };
            });
          SessionStorage.set("provider_list_filter", this.providerList);
        }
      } catch (ex) {
        this.$dialog.errorException(ex);
      }
    }
    await this.onSearch();
  },
  computed: {
    ...mapState("auth", ["role"]),
    numberFormat() {
      return (number, digit = 2, comma = true) =>
        new Intl.NumberFormat("en-US", {
          minimumFractionDigits: digit,
          maximumFractionDigits: digit,
          useGrouping: comma
        }).format(number);
    },
    convertToFloat() {
      return number => parseFloat(this.numberFormat(number, 2, false));
    },
    bgFunc() {
      return inValue => {
        const value = this.convertToFloat(inValue.replace(/,/g, ""));

        if (value > 0) {
          return "text-green-8 text-bold";
        }
        if (value == 0) {
          return "";
        }
        return "text-red-10 text-bold";
      };
    }
  },
  methods: {
    ...mapActions("report/v2", ["getAllReport"]),
    ...mapActions("group/v2", ["load_list"]),
    ...mapActions("provider", { load_provider: "load" }),
    getDateTime(date, time) {
      let dateFormat = "YYYY-MM-DD";
      let timeFormat = "HH:mm:ss";
      return (
        dayjs(
          `${dayjs(date).format(dateFormat)} ${dayjs(time).format(timeFormat)}`,
          "YYYY-MM-DD HH:mm:ss"
        )
          .utc()
          .format(`${dateFormat} ${timeFormat}`) + "Z"
      );
      // return `${dayjs(date).format('YYYY-MM-DD')}T${dayjs(time).format('HH:mm:ss')}Z`;
    },
    getFilterParameter({ filter = this.filter, pagination = this.pagination }) {
      if (this.$route.meta.level) {
        filter.level = this.$route.meta.level;
      }
      if (this.$route.params.id) {
        filter.parent_id = this.$route.params.id;
      } else {
        delete filter.parent_id;
      }
      let start = undefined;
      let end = undefined;
      if (this.dateFilter.startDate) {
        if (this.dateFilter.startTime) {
          start = this.getDateTime(
            this.dateFilter.startDate,
            this.dateFilter.startTime
          );
        } else {
          start = this.getDateTime(
            this.dateFilter.startDate,
            new Date().setHours(0, 0, 0, 0)
          );
        }
      }
      if (this.dateFilter.endDate) {
        if (this.dateFilter.endTime) {
          end = this.getDateTime(
            this.dateFilter.endDate,
            this.dateFilter.endTime
          );
        } else {
          end = this.getDateTime(
            this.dateFilter.endDate,
            new Date().setHours(23, 59, 59, 999)
          );
        }
      }
      return {
        // ...filter,
        // ...pagination,
        typeCode: this.game_type.join(",")
          ? this.game_type.join(",")
          : undefined,
        providerCode: this.provider_code.join(",")
          ? this.provider_code.join(",")
          : undefined,
        start: new Date(start).toISOString(),
        end: new Date(end).toISOString()
      };
    },
    async onRequest(props) {
      try {
        this.loading = true;
        const parameters = this.getFilterParameter(props);
        const { data } = await this.getAllReport({
          ...parameters
        });
        this.data = data.results;
        // if (this.groupList.length == 0) {
        //   this.groupList = data.profile.groups.filter(
        //     (item, index) =>
        //       data.profile.groups.findIndex(r => r.code == item.code) == index
        //   );
        //   this.game_type = this.groupList
        //     .filter(
        //       (item, index) =>
        //         this.groupList.findIndex(r => r.code == item.code) == index
        //     )
        //     .map(x => x.code);
        // }
        // this.data.splice(0, this.data.length, ...[data]);
        // this.pagination.page = 1;
        // this.pagination.rowsPerPage = 1;
        // this.pagination.rowsNumber = 1;
      } catch (ex) {
        this.$dialog.errorException(ex);
      }
      this.loading = false;
    },
    async onSearch() {
      await this.onRequest({
        pagination: this.pagination,
        filter: this.filter
      });
    },
    getWL(member, index) {
      if (member.level > 3) {
        return member.winLoss;
      } else {
        let targetReport = [...this.data.report];

        targetReport = targetReport.slice(index + 1);

        return targetReport.reverse().reduce((a, b) => a.winLoss - b.winLoss);
      }
    },
    getWinLose(level) {
      let report = [...this.data.report];
      let wl = 0;
      if (report.length === 0) return wl;

      if (level > 3) {
        const targetReport = report.find(x => x.level === level);

        if (targetReport) wl = targetReport.winLoss;
      } else {
        report = report.filter(x => x.level > level);

        wl = report.reverse().reduce((a, b) => a.winLoss - b.winLoss);
      }

      // if (member.level > 3) {
      //   return member.winLoss;
      // } else {
      //   let targetReport = [...this.data.report];
      //   targetReport = targetReport.slice(index + 1);
      //   return targetReport.reverse().reduce((a, b) => a.winLoss - b.winLoss);
      // }

      return this.numberWithCommas(wl);
    },
    numberWithCommas(x) {
      return x.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ",");
    }
  }
};
</script>
<style lang="scss">
label {
  margin: 8px 0;
}

.el-input__inner,
.q-field--outlined .q-field__control:before {
  border-color: black;
}
</style>
